#include "supply.h"

template <class Key, class Item>
Dictionary<Key, Item>* allocateDictionary(bool v, Key key, Item item)
/*
   purpose : allocate a Dictionary on the heap.

   input   : v = true <=> keys in the dictionary must be unique.
             key  - type specifier, for Key object,
             item - type specifier for Item object.
             It suffices to pass temporary objects for the type specifiers.
             i.e. call allocateDictionary(v, key(), Item())
   returns : ptr to the allocated Dictionary object.
*/
{
   return (new ListDictionary<Key, Item>(v));
}

template <class Key, class Item>
void deallocateDictionary(Dictionary<Key, Item>* pd)
/*
   purpose : deallocates a Dictionary.

   input   : pd ptr to the Dictionary that needs to be deallocated.
   note    : must be called for each allocated Dictionary.
*/
{
   delete pd;
}


